SystemOrganization addCategory: #GroupManager!
SystemOrganization addCategory: #'GroupManager-Announcements'!

Announcement subclass: #AbstractGroupAnnouncement
	instanceVariableNames: 'group holder'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GroupManager-Announcements'!

AbstractGroupAnnouncement subclass: #AGroupHasBeenAdded
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GroupManager-Announcements'!

!AGroupHasBeenAdded class methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 4/14/2011 16:32'!
group: aGroup into: anHolder

	^ self group: aGroup from: anHolder! !

AbstractGroupAnnouncement subclass: #AGroupHasBeenCreated
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GroupManager-Announcements'!

AbstractGroupAnnouncement subclass: #AGroupHasBeenRegistered
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GroupManager-Announcements'!

!AGroupHasBeenRegistered class methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 4/14/2011 13:40'!
with: aGroup

	^ self new group: aGroup! !

!AGroupHasBeenRegistered methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 4/14/2011 13:39'!
group

		^ group! !

!AGroupHasBeenRegistered methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 4/14/2011 13:39'!
group: anObject
	
		group := anObject! !

AbstractGroupAnnouncement subclass: #AGroupHasBeenRemoved
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GroupManager-Announcements'!

AbstractGroupAnnouncement subclass: #AGroupHasBeenRenamed
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GroupManager-Announcements'!

AbstractGroupAnnouncement subclass: #AGroupHasBeenUnregistered
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GroupManager-Announcements'!

!AGroupHasBeenUnregistered class methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 4/14/2011 13:40'!
with: aGroup

	^ self new group: aGroup! !

!AGroupHasBeenUnregistered methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 4/14/2011 13:39'!
group

		^ group! !

!AGroupHasBeenUnregistered methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 4/14/2011 13:39'!
group: anObject
	
		group := anObject! !

!AbstractGroupAnnouncement class methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 4/14/2011 22:40'!
group: aGroup

	^ self new 
		group: aGroup;
		yourself! !

!AbstractGroupAnnouncement class methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 4/14/2011 16:32'!
group: aGroup from: anHolder

	^ self new 
		group: aGroup;
		holder: anHolder;
		yourself! !

!AbstractGroupAnnouncement methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 4/14/2011 16:31'!
group

		^ group! !

!AbstractGroupAnnouncement methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 4/14/2011 16:31'!
group: anObject
	
		group := anObject! !

!AbstractGroupAnnouncement methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 4/14/2011 16:31'!
holder

		^ holder! !

!AbstractGroupAnnouncement methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 4/14/2011 16:31'!
holder: anObject
	
		holder := anObject! !

SystemAnnouncer subclass: #GroupAnnouncer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GroupManager-Announcements'!

!OrderedCollection methodsFor: '*GroupManager' stamp: 'BenjaminVanRyseghem 5/9/2011 16:04'!
removeDuplicates

	| iterator |
	self ifEmpty: [ ^ self ].
	iterator := 1.
	[ iterator <= self size ]
		whileTrue: [ | each newIndex |
			each := self at: iterator.			
			[ newIndex := (self indexOf: each startingAt: iterator+1).
			newIndex > 0 ]
				whileTrue: [ self removeAt: newIndex ].
			iterator := iterator + 1.
	 ]! !

Object subclass: #AbstractGroup
	instanceVariableNames: 'name readOnly removable sortBlock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GroupManager'!

!AbstractGroup class methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 3/18/2011 14:06'!
named: aString

	^ self new name: aString! !

!AbstractGroup class methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 5/4/2011 11:51'!
new

	| instance |
	instance := self basicNew initialize.
	GroupAnnouncer announcer announce: (AGroupHasBeenCreated group: instance).
	^ instance! !

!AbstractGroup methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 3/18/2011 14:00'!
beReadOnly

	readOnly := true! !

!AbstractGroup methodsFor: 'polymorphism' stamp: 'BenjaminVanRyseghem 3/28/2011 13:50'!
blocks

	^ { [ self elements ] }! !

!AbstractGroup methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 3/18/2011 14:22'!
elements

	^ self subclassResponsibility! !

!AbstractGroup methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/18/2011 16:57'!
ifAllowed: aBlock

	^ self ifAllowed: aBlock ifNot: []! !

!AbstractGroup methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/18/2011 16:57'!
ifAllowed: aBlock ifNot: anotherBlock

	^ self isReadOnly
		ifTrue: anotherBlock
		ifFalse: aBlock! !

!AbstractGroup methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/18/2011 14:01'!
initialize

	super initialize.
	readOnly := false! !

!AbstractGroup methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 4/14/2011 21:55'!
isReadOnly

	^ readOnly == true! !

!AbstractGroup methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 3/18/2011 14:03'!
name

	^ name! !

!AbstractGroup methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 3/18/2011 14:04'!
name: aString

	self ifAllowed: [ name := aString ]! !

!AbstractGroup methodsFor: 'printing' stamp: 'BenjaminVanRyseghem 3/29/2011 11:20'!
printOn: aStream

	| className article |
	className := self class name.
	article := className first isVowel
				ifTrue: ['an']
				ifFalse: ['a'].
	aStream
		nextPutAll: article;
		nextPut: Character space;
		nextPutAll: className;
		nextPutAll: ' ( ';
		nextPutAll: self name asString;
		nextPutAll: ' )'.! !

!AbstractGroup methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 3/24/2011 13:41'!
removable

	^ removable ifNil: [ removable := true ]! !

!AbstractGroup methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 3/24/2011 13:39'!
removable: aBoolean

	removable := aBoolean! !

!AbstractGroup methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/24/2011 13:20'!
sortBlock

	^ sortBlock ifNil: [ sortBlock := [:a :b | a printString <= b printString ]]! !

!AbstractGroup methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/24/2011 13:16'!
sortBlock: aBlock

	sortBlock := aBlock! !

!AbstractGroup methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 3/21/2011 15:32'!
unregister

	GroupsManager unregister: self! !

AbstractGroup subclass: #DynamicGroup
	instanceVariableNames: 'blocks'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GroupManager'!

!DynamicGroup class methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 5/4/2011 11:51'!
named: aString block: aBlock

	| instance |
	instance := self basicNew
					name: aString;
					block: aBlock
					initialize;
					yourself.
	GroupAnnouncer announcer announce: (AGroupHasBeenCreated group: instance).
	^ instance! !

!DynamicGroup class methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 4/14/2011 22:41'!
named: aString blocks: aCollection

	| instance |
	instance := self basicNew
					name: aString;
					blocks: aCollection;
					initialize;
					yourself.
	GroupAnnouncer announcer announce: (AGroupHasBeenCreated group: instance).
	^ instance! !

!DynamicGroup methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/28/2011 13:21'!
block: aBlock

	blocks := { aBlock }! !

!DynamicGroup methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/28/2011 13:14'!
blocks

	^ blocks! !

!DynamicGroup methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/28/2011 13:14'!
blocks: aBlock

	blocks := aBlock! !

!DynamicGroup methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 5/9/2011 16:05'!
elements

	^ (self blocks gather: [:block | block value]) copy asOrderedCollection removeDuplicates! !

!DynamicGroup methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 4/14/2011 22:47'!
initialize

	super initialize.
	readOnly := true.
	blocks ifNil: [ blocks := {[{}]} ]! !

!DynamicGroup methodsFor: 'testing' stamp: 'BenjaminVanRyseghem 3/22/2011 17:06'!
isFillable

	^ false! !

!DynamicGroup methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/28/2011 13:48'!
or: aGroup

	| instance |
	instance :=  self class
					named: (self name, ' + ', aGroup name)
					blocks: (self blocks union: aGroup blocks).
	( self isReadOnly or: [ aGroup isReadOnly ]) ifTrue: [ instance beReadOnly ].
	instance removable: ( self removable or: [ aGroup removable ]).
	^ instance! !

!DynamicGroup methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/24/2011 13:14'!
sortBlock: aBlock

	sortBlock := aBlock! !

AbstractGroup subclass: #StaticGroup
	instanceVariableNames: 'elements'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GroupManager'!

!StaticGroup class methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 3/18/2011 14:29'!
named: aString with: aCollection

	^ (super named: aString) with: aCollection! !

!StaticGroup methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 3/18/2011 14:05'!
add: anElement

	^ self ifAllowed: [ elements add: anElement ]! !

!StaticGroup methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 3/28/2011 14:04'!
addAll: aCollection

	^ self ifAllowed: [ elements addAll: aCollection ]! !

!StaticGroup methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 3/18/2011 14:22'!
elements

	^ elements copy! !

!StaticGroup methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/18/2011 14:01'!
initialize

	super initialize.
	readOnly := false! !

!StaticGroup methodsFor: 'testing' stamp: 'BenjaminVanRyseghem 3/22/2011 17:06'!
isFillable

	^ true! !

!StaticGroup methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 3/28/2011 13:59'!
or: aGroup

	^ (aGroup class == self class)
		ifTrue: [| instance elts |
			elts := OrderedCollection new.
			elts addAll: self elements.
			elts addAll: aGroup elements.
			instance := self class
				named: self name, ' + ', aGroup name
				with: elts.
			( self isReadOnly or: [ aGroup isReadOnly ]) ifTrue: [ instance beReadOnly ].
			instance removable: ( self removable or: [ aGroup removable ]).
			instance ]
		ifFalse: [ aGroup or: self ]! !

!StaticGroup methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 3/18/2011 14:05'!
remove: anElement

	^ self ifAllowed: [ elements remove: anElement ]! !

!StaticGroup methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/18/2011 14:30'!
with: aCollection

	self ifAllowed: [ elements := aCollection ]! !

Object subclass: #GroupsHolder
	instanceVariableNames: 'groups'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GroupManager'!

!GroupsHolder methodsFor: 'adding' stamp: 'BenjaminVanRyseghem 3/28/2011 14:04'!
add: aCollection into: aGroup

	aGroup
		ifAllowed: [ aGroup addAll: aCollection ]
		ifNot: [ self openReadOnlyError ]! !

!GroupsHolder methodsFor: 'dynamic group' stamp: 'BenjaminVanRyseghem 4/14/2011 16:13'!
addADynamicGroupSilentlyNamed: entry block: aBlock 
	
	(self includesAGroupNamed: entry)
		ifTrue: [ 
			self openError.
			^ nil]
		ifFalse: [ | group |
			group:= self groups
						add: 
							(DynamicGroup 
								named: entry 
								block: aBlock).
			GroupAnnouncer announcer announce: ( AGroupHasBeenAdded group: group into: self ).
			^ group]! !

!GroupsHolder methodsFor: 'dynamic group' stamp: 'BenjaminVanRyseghem 4/14/2011 16:59'!
addADynamicGroupSilentlyNamed: entry blocks: aCollection 
	
	(self includesAGroupNamed: entry)
		ifTrue: [ 
			self openError.
			^ nil]
		ifFalse: [ | group |
			group :=  self groups
						add: 
							(DynamicGroup 
								named: entry 
								blocks: aCollection).

			GroupAnnouncer announcer announce: ( AGroupHasBeenAdded group: group into: self ).
			^ group]! !

!GroupsHolder methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 3/18/2011 14:26'!
addAGroup

self halt! !

!GroupsHolder methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 4/14/2011 16:12'!
addAGroup: aGroup

	(self includesAGroupNamed: aGroup name)
		ifTrue: [ 
			self openError.
			^ nil].
	self groups add: aGroup.
	GroupAnnouncer announcer announce: ( AGroupHasBeenAdded group: aGroup into: self ).! !

!GroupsHolder methodsFor: 'static group' stamp: 'BenjaminVanRyseghem 4/14/2011 16:14'!
addAStaticGroupSilentlyNamed: entry with: aCollection

	(self includesAGroupNamed: entry)
		ifTrue: [ 
			self openError.
			^ nil]
		ifFalse: [ | group |
			group := self groups add: (StaticGroup named: entry with: aCollection).
			GroupAnnouncer announcer announce: ( AGroupHasBeenAdded group: group into: self ).
			^ group ]! !

!GroupsHolder methodsFor: 'static group' stamp: 'BenjaminVanRyseghem 3/18/2011 14:26'!
addAnEmptyStaticGroupSilentlyNamed: entry

	^ self addAStaticGroupSilentlyNamed: entry with: OrderedCollection new! !

!GroupsHolder methodsFor: 'adding' stamp: 'BenjaminVanRyseghem 3/21/2011 15:26'!
createADynamicGroup

	| entry aClass aSelector |
	entry := UIManager default textEntry: 'Name of the new group:' title: 'Create a new group' entryText: 'MyNewGroupName'.
	aClass := nil.
	aSelector := nil.
	^ entry ifNotNil: [ self addADynamicGroupSilentlyNamed: entry model: aClass selector: aSelector ].! !

!GroupsHolder methodsFor: 'adding' stamp: 'BenjaminVanRyseghem 3/22/2011 17:04'!
createAnEmptyStaticGroup

	| entry |
	entry := UIManager default request: 'Name of the new group:' initialAnswer: '' title: 'Create a new group'.
	^ (entry isNil or: [entry isEmpty])
		ifFalse: [ self addAnEmptyStaticGroupSilentlyNamed: entry ]! !

!GroupsHolder methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 3/18/2011 14:40'!
groupNamed: aString

	^ self groups detect: [:each | each name = aString]! !

!GroupsHolder methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 3/18/2011 15:04'!
groups

	^  groups ifNil: [ groups := OrderedCollection new ]! !

!GroupsHolder methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 3/18/2011 14:32'!
groupsNames

	^ self groups collect: [:group | group name ]! !

!GroupsHolder methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 4/14/2011 16:00'!
includes: aGroup

	^ self groups includes: aGroup! !

!GroupsHolder methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 3/18/2011 14:37'!
includesAGroupNamed: aName

	^ self groupsNames includes: aName! !

!GroupsHolder methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 8/21/2011 11:06'!
isEmpty

	^ self groups isEmpty.! !

!GroupsHolder methodsFor: 'windows' stamp: 'BenjaminVanRyseghem 3/22/2011 18:14'!
openError

	UIManager default alert: 'This group already exists' title: 'Already exists'! !

!GroupsHolder methodsFor: 'windows' stamp: 'BenjaminVanRyseghem 3/22/2011 18:14'!
openReadOnlyError

	UIManager default  alert: 'This group is read only' title: 'Access error'! !

!GroupsHolder methodsFor: 'windows' stamp: 'BenjaminVanRyseghem 3/22/2011 18:15'!
openRemoveDialogOn: aGroup

	^UIManager default confirm: ('Dou you really want to delete the group named ', aGroup name)! !

!GroupsHolder methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 3/18/2011 16:58'!
remove: aClass from: aGroup

	^ aGroup
		ifAllowed: [ aGroup remove: aClass ]
		ifNot: [ self openReadOnlyError ]! !

!GroupsHolder methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 3/28/2011 17:22'!
removeAGroup: aGroup

	| yesIWantToRemoveTheGroup |
	yesIWantToRemoveTheGroup := self openRemoveDialogOn: aGroup.
	yesIWantToRemoveTheGroup
		ifFalse: [ ^ nil ].
	^ self removeAGroupSilently: aGroup
! !

!GroupsHolder methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 9/15/2011 16:57'!
removeAGroupSilently: aGroup

	| group |
	 aGroup removable
		ifFalse: [ ^ self openReadOnlyError ].
	group :=  self groups remove: aGroup ifAbsent: [].
	GroupAnnouncer announcer announce: ( AGroupHasBeenRemoved group: aGroup from: self ).
	^ group! !

!GroupsHolder methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 4/14/2011 16:16'!
renameAGroup: aGroup

	| entry |
	entry := UIManager default request: 'New name of the group' initialAnswer: aGroup name title: 'Rename a group'.
	(entry isNil or: [entry isEmpty]) ifTrue: [^ aGroup].
	(self includesAGroupNamed: entry)
		ifTrue: [ ^ self openError ].
	aGroup isReadOnly
		ifTrue: [ ^ self openReadOnlyError ].
	aGroup name: entry.
	GroupAnnouncer announcer announce: ( AGroupHasBeenRenamed group: aGroup from: self ).
	^ aGroup	
! !

!GroupsHolder methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 3/18/2011 14:54'!
sort: aBlock

	^ groups := self groups sort: aBlock! !

Object subclass: #GroupsManager
	instanceVariableNames: 'groups'
	classVariableNames: 'CurrentManager'
	poolDictionaries: ''
	category: 'GroupManager'!

!GroupsManager class methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/21/2011 16:08'!
current

	^ CurrentManager ifNil: [ CurrentManager := self new ]! !

!GroupsManager class methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 3/21/2011 16:09'!
register: aGroup

	self current register: aGroup! !

!GroupsManager class methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/21/2011 16:08'!
setCurrentManager: aManager

	CurrentManager := aManager! !

!GroupsManager class methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 3/21/2011 16:09'!
unregister: aGroup

	self current unregister: aGroup! !

!GroupsManager methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/21/2011 16:11'!
initialize

	super initialize.
	groups := OrderedCollection new! !

!GroupsManager methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 4/14/2011 17:01'!
register: aGroup

	groups add: aGroup.
	GroupAnnouncer announcer announce: (AGroupHasBeenRegistered with: aGroup)! !

!GroupsManager methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 4/14/2011 17:01'!
unregister: aGroup

	groups remove: aGroup.
	GroupAnnouncer announcer announce: (AGroupHasBeenUnregistered with: aGroup)! !
